Package org.apache.sysds.runtime.compress.colgroup

## Class ColGroupUncompressed

- java.lang.Object
- - org.apache.sysds.runtime.compress.colgroup.AColGroup
  - - org.apache.sysds.runtime.compress.colgroup.ColGroupUncompressed

- All Implemented Interfaces:
    `Serializable`

      public class ColGroupUncompressed
      extends AColGroup

  Column group type for columns that are stored as dense arrays of doubles. Uses a MatrixBlock internally to store the column contents.
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.apache.sysds.runtime.compress.colgroup.AColGroup

      `AColGroup.CompressionType`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `ColGroupUncompressed​(MatrixBlock data)` | Constructor for allocating a single uncompressed column group.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `AColGroup` | `binaryRowOpLeft​(BinaryOperator op, double[] v, boolean isRowSafe)` | Perform a binary row operation.
    `AColGroup` | `binaryRowOpRight​(BinaryOperator op, double[] v, boolean isRowSafe)` | Perform a binary row operation.
    `CM_COV_Object` | `centralMoment​(CMOperator op, int nRows)` | Central Moment instruction executed on a column group.
    `void` | `computeColSums​(double[] c, int nRows)` | Compute the column sum
    `boolean` | `containsValue​(double pattern)` | Detect if the column group contains a specific value.
    `AColGroup` | `copy()` | Get a copy of this column group note this is only a shallow copy.
    `static AColGroup` | `create​(int[] colIndexes, MatrixBlock rawBlock, boolean transposed)` | Main constructor for Uncompressed ColGroup.
    `void` | `decompressToDenseBlock​(DenseBlock db, int rl, int ru, int offR, int offC)` | Decompress into the DenseBlock.
    `void` | `decompressToSparseBlock​(SparseBlock ret, int rl, int ru, int offR, int offC)` | Decompress into the SparseBlock.
    `long` | `estimateInMemorySize()` | Get the upper bound estimate of in memory allocation for the column group.
    `org.apache.sysds.runtime.compress.colgroup.AColGroup.ColGroupType` | `getColGroupType()` |
    `AColGroup.CompressionType` | `getCompType()` | Obtain the compression type.
    `double` | `getCost​(ComputationCostEstimator e, int nRows)` | Get the computation cost associated with this column group.
    `MatrixBlock` | `getData()` | Access for superclass
    `long` | `getExactSizeOnDisk()` | Returns the exact serialized size of column group.
    `double` | `getIdx​(int r, int colIdx)` | Get the value at a colGroup specific row/column index position.
    `double` | `getMax()` | Short hand method for getting maximum value contained in this column group.
    `double` | `getMin()` | Short hand method for getting minimum value contained in this column group.
    `long` | `getNumberNonZeros​(int nRows)` | Get the number of nonZeros contained in this column group.
    `int` | `getNumValues()` | Obtain number of distinct tuples in contained sets of values associated with this column group.
    `void` | `leftMultByAColGroup​(AColGroup lhs, MatrixBlock result)` | Left side matrix multiplication with a column group that is transposed.
    `void` | `leftMultByMatrix​(MatrixBlock matrix, MatrixBlock result, int rl, int ru)` |
    `void` | `leftMultByMatrixNoPreAgg​(MatrixBlock matrix, MatrixBlock result, int rl, int ru, int cl, int cu)` | Left multiply with this column group.
    `void` | `readFields​(DataInput in)` | Deserialize column group from data input.
    `AColGroup` | `replace​(double pattern, double replace)` | Make a copy of the column group values, and replace all values that match pattern with replacement value.
    `AColGroup` | `rexpandCols​(int max, boolean ignore, boolean cast, int nRows)` | Expand the column group to multiple columns.
    `AColGroup` | `rightMultByMatrix​(MatrixBlock right)` | Right matrix multiplication with this column group.
    `AColGroup` | `scalarOperation​(ScalarOperator op)` | Perform the specified scalar operation directly on the compressed column group, without decompressing individual cells if possible.
    `String` | `toString()` |
    `void` | `tsmm​(MatrixBlock ret, int nRows)` | Do a transposed self matrix multiplication on the left side t(x) %*% x.
    `void` | `tsmmAColGroup​(AColGroup lhs, MatrixBlock result)` | Matrix multiply with this other column group, but: 1.
    `void` | `unaryAggregateOperations​(AggregateUnaryOperator op, double[] result, int nRows, int rl, int ru)` | Unary Aggregate operator, since aggregate operators require new object output, the output becomes an uncompressed matrix.
    `AColGroup` | `unaryOperation​(UnaryOperator op)` |
    `void` | `write​(DataOutput out)` | Serializes column group to data output.

    - ### Methods inherited from class org.apache.sysds.runtime.compress.colgroup.AColGroup

      `colSum, decompressToDenseBlock, decompressToSparseBlock, get, getColIndices, getNumCols, shiftColIndices, sliceColumn, sliceColumns`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### ColGroupUncompressed

          public ColGroupUncompressed​(MatrixBlock data)

      Constructor for allocating a single uncompressed column group.
      Parameters:
        `data` - matrix block

  - ### Method Detail

    - #### create

          public static AColGroup create​(int[] colIndexes,
                                         MatrixBlock rawBlock,
                                         boolean transposed)

      Main constructor for Uncompressed ColGroup.
      Parameters:
        `colIndexes` - Indices (relative to the current block) of the columns that this column group represents.
        `rawBlock` - The uncompressed block; uncompressed data must be present at the time that the constructor is called
        `transposed` - Says if the input matrix raw block have been transposed.
      Returns:
        AColGroup.

    - #### getCompType

          public AColGroup.CompressionType getCompType()

      Description copied from class: `AColGroup`
      Obtain the compression type.
      Specified by:
        `getCompType` in class `AColGroup`
      Returns:
        How the elements of the column group are compressed.

    - #### getColGroupType

          public org.apache.sysds.runtime.compress.colgroup.AColGroup.ColGroupType getColGroupType()

    - #### getData

          public MatrixBlock getData()

      Access for superclass
      Returns:
        direct pointer to the internal representation of the columns

    - #### estimateInMemorySize

          public long estimateInMemorySize()

      Description copied from class: `AColGroup`
      Get the upper bound estimate of in memory allocation for the column group.
      Overrides:
        `estimateInMemorySize` in class `AColGroup`
      Returns:
        an upper bound on the number of bytes used to store this ColGroup in memory.

    - #### decompressToDenseBlock

          public void decompressToDenseBlock​(DenseBlock db,
                                             int rl,
                                             int ru,
                                             int offR,
                                             int offC)

      Description copied from class: `AColGroup`
      Decompress into the DenseBlock. (no NNZ handling)
      Specified by:
        `decompressToDenseBlock` in class `AColGroup`
      Parameters:
        `db` - Target DenseBlock
        `rl` - Row to start decompression from
        `ru` - Row to end decompression at
        `offR` - Row offset into the target to decompress
        `offC` - Column offset into the target to decompress

    - #### decompressToSparseBlock

          public void decompressToSparseBlock​(SparseBlock ret,
                                              int rl,
                                              int ru,
                                              int offR,
                                              int offC)

      Description copied from class: `AColGroup`
      Decompress into the SparseBlock. (no NNZ handling) Note this method is allowing to calls to append since it is assumed that the sparse column indexes are sorted afterwards
      Specified by:
        `decompressToSparseBlock` in class `AColGroup`
      Parameters:
        `ret` - Target SparseBlock
        `rl` - Row to start decompression from
        `ru` - Row to end decompression at
        `offR` - Row offset into the target to decompress
        `offC` - Column offset into the target to decompress

    - #### getIdx

          public double getIdx​(int r,
                               int colIdx)

      Description copied from class: `AColGroup`
      Get the value at a colGroup specific row/column index position.
      Specified by:
        `getIdx` in class `AColGroup`
      Parameters:
        `r` - row
        `colIdx` - column index in the _colIndexes.
      Returns:
        value at the row/column index position

    - #### leftMultByMatrixNoPreAgg

          public void leftMultByMatrixNoPreAgg​(MatrixBlock matrix,
                                               MatrixBlock result,
                                               int rl,
                                               int ru,
                                               int cl,
                                               int cu)

      Description copied from class: `AColGroup`
      Left multiply with this column group.
      Specified by:
        `leftMultByMatrixNoPreAgg` in class `AColGroup`
      Parameters:
        `matrix` - The matrix to multiply with on the left
        `result` - The result to output the values into, always dense for the purpose of the column groups parallelizing
        `rl` - The row to begin the multiplication from on the lhs matrix
        `ru` - The row to end the multiplication at on the lhs matrix
        `cl` - The column to begin the multiplication from on the lhs matrix
        `cu` - The column to end the multiplication at on the lhs matrix

    - #### leftMultByMatrix

          public void leftMultByMatrix​(MatrixBlock matrix,
                                       MatrixBlock result,
                                       int rl,
                                       int ru)

    - #### scalarOperation

          public AColGroup scalarOperation​(ScalarOperator op)

      Description copied from class: `AColGroup`
      Perform the specified scalar operation directly on the compressed column group, without decompressing individual cells if possible.
      Specified by:
        `scalarOperation` in class `AColGroup`
      Parameters:
        `op` - operation to perform
      Returns:
        version of this column group with the operation applied

    - #### unaryOperation

          public AColGroup unaryOperation​(UnaryOperator op)

      Specified by:
        `unaryOperation` in class `AColGroup`

    - #### binaryRowOpLeft

          public AColGroup binaryRowOpLeft​(BinaryOperator op,
                                           double[] v,
                                           boolean isRowSafe)

      Description copied from class: `AColGroup`
      Perform a binary row operation.
      Specified by:
        `binaryRowOpLeft` in class `AColGroup`
      Parameters:
        `op` - The operation to execute
        `v` - The vector of values to apply, should be same length as dictionary length.
        `isRowSafe` - True if the binary op is applied to an entire zero row and all results are zero
      Returns:
        A updated column group with the new values.

    - #### binaryRowOpRight

          public AColGroup binaryRowOpRight​(BinaryOperator op,
                                            double[] v,
                                            boolean isRowSafe)

      Description copied from class: `AColGroup`
      Perform a binary row operation.
      Specified by:
        `binaryRowOpRight` in class `AColGroup`
      Parameters:
        `op` - The operation to execute
        `v` - The vector of values to apply, should be same length as dictionary length.
        `isRowSafe` - True if the binary op is applied to an entire zero row and all results are zero
      Returns:
        A updated column group with the new values.

    - #### unaryAggregateOperations

          public void unaryAggregateOperations​(AggregateUnaryOperator op,
                                               double[] result,
                                               int nRows,
                                               int rl,
                                               int ru)

      Description copied from class: `AColGroup`
      Unary Aggregate operator, since aggregate operators require new object output, the output becomes an uncompressed matrix.
      Specified by:
        `unaryAggregateOperations` in class `AColGroup`
      Parameters:
        `op` - The operator used
        `result` - The output matrix block
        `nRows` - The total number of rows in the Column Group
        `rl` - The Starting Row to do aggregation from
        `ru` - The last Row to do aggregation to (not included)

    - #### readFields

          public void readFields​(DataInput in)
                          throws IOException

      Description copied from class: `AColGroup`
      Deserialize column group from data input.
      Overrides:
        `readFields` in class `AColGroup`
      Parameters:
        `in` - data input
      Throws:
        `IOException` - if IOException occurs

    - #### write

          public void write​(DataOutput out)
                     throws IOException

      Description copied from class: `AColGroup`
      Serializes column group to data output.
      Overrides:
        `write` in class `AColGroup`
      Parameters:
        `out` - data output
      Throws:
        `IOException` - if IOException occurs

    - #### getExactSizeOnDisk

          public long getExactSizeOnDisk()

      Description copied from class: `AColGroup`
      Returns the exact serialized size of column group. This can be used for example for buffer preallocation.
      Overrides:
        `getExactSizeOnDisk` in class `AColGroup`
      Returns:
        exact serialized size for column group

    - #### getMin

          public double getMin()

      Description copied from class: `AColGroup`
      Short hand method for getting minimum value contained in this column group.
      Specified by:
        `getMin` in class `AColGroup`
      Returns:
        The minimum value contained in this ColumnGroup

    - #### getMax

          public double getMax()

      Description copied from class: `AColGroup`
      Short hand method for getting maximum value contained in this column group.
      Specified by:
        `getMax` in class `AColGroup`
      Returns:
        The maximum value contained in this ColumnGroup

    - #### tsmm

          public final void tsmm​(MatrixBlock ret,
                                 int nRows)

      Description copied from class: `AColGroup`
      Do a transposed self matrix multiplication on the left side t(x) %*% x. but only with this column group. This gives better performance since there is no need to iterate through all the rows of the matrix, but the execution can be limited to its number of distinct values. Note it only calculate the upper triangle
      Specified by:
        `tsmm` in class `AColGroup`
      Parameters:
        `ret` - The return matrix block [numColumns x numColumns]
        `nRows` - The number of rows in the column group

    - #### copy

          public AColGroup copy()

      Description copied from class: `AColGroup`
      Get a copy of this column group note this is only a shallow copy. Meaning only the object wrapping index structures, column indexes and dictionaries are copied.
      Specified by:
        `copy` in class `AColGroup`
      Returns:
        Get a copy of this column group.

    - #### containsValue

          public boolean containsValue​(double pattern)

      Description copied from class: `AColGroup`
      Detect if the column group contains a specific value.
      Specified by:
        `containsValue` in class `AColGroup`
      Parameters:
        `pattern` - The value to look for.
      Returns:
        boolean saying true if the value is contained.

    - #### getNumberNonZeros

          public long getNumberNonZeros​(int nRows)

      Description copied from class: `AColGroup`
      Get the number of nonZeros contained in this column group.
      Specified by:
        `getNumberNonZeros` in class `AColGroup`
      Parameters:
        `nRows` - The number of rows in the column group, this is used for groups that does not contain information about how many rows they have.
      Returns:
        The nnz.

    - #### leftMultByAColGroup

          public void leftMultByAColGroup​(AColGroup lhs,
                                          MatrixBlock result)

      Description copied from class: `AColGroup`
      Left side matrix multiplication with a column group that is transposed.
      Specified by:
        `leftMultByAColGroup` in class `AColGroup`
      Parameters:
        `lhs` - The left hand side Column group to multiply with, the left hand side should be considered transposed.
        `result` - The result matrix to insert the result of the multiplication into

    - #### tsmmAColGroup

          public void tsmmAColGroup​(AColGroup lhs,
                                    MatrixBlock result)

      Description copied from class: `AColGroup`
      Matrix multiply with this other column group, but: 1. Only output upper triangle values. 2. Multiply both ways with "this" being on the left and on the right. It should be guaranteed that the input is not the same as the caller of the method. The second step is achievable by treating the initial multiplied matrix, and adding its values to the correct locations in the output.
      Specified by:
        `tsmmAColGroup` in class `AColGroup`
      Parameters:
        `lhs` - The other Column group to multiply with
        `result` - The result matrix to put the results into

    - #### rightMultByMatrix

          public AColGroup rightMultByMatrix​(MatrixBlock right)

      Description copied from class: `AColGroup`
      Right matrix multiplication with this column group. This method can return null, meaning that the output overlapping group would have been empty.
      Specified by:
        `rightMultByMatrix` in class `AColGroup`
      Parameters:
        `right` - The MatrixBlock on the right of this matrix multiplication
      Returns:
        The new Column Group or null that is the result of the matrix multiplication.

    - #### getNumValues

          public int getNumValues()

      Description copied from class: `AColGroup`
      Obtain number of distinct tuples in contained sets of values associated with this column group. If the column group is uncompressed the number or rows is returned.
      Specified by:
        `getNumValues` in class `AColGroup`
      Returns:
        the number of distinct sets of values associated with the bitmaps in this column group

    - #### replace

          public AColGroup replace​(double pattern,
                                   double replace)

      Description copied from class: `AColGroup`
      Make a copy of the column group values, and replace all values that match pattern with replacement value.
      Specified by:
        `replace` in class `AColGroup`
      Parameters:
        `pattern` - The value to look for
        `replace` - The value to replace the other value with
      Returns:
        A new Column Group, reusing the index structure but with new values.

    - #### computeColSums

          public void computeColSums​(double[] c,
                                     int nRows)

      Description copied from class: `AColGroup`
      Compute the column sum
      Specified by:
        `computeColSums` in class `AColGroup`
      Parameters:
        `c` - The array to add the column sum to.
        `nRows` - The number of rows in the column group.

    - #### centralMoment

          public CM_COV_Object centralMoment​(CMOperator op,
                                             int nRows)

      Description copied from class: `AColGroup`
      Central Moment instruction executed on a column group.
      Specified by:
        `centralMoment` in class `AColGroup`
      Parameters:
        `op` - The Operator to use.
        `nRows` - The number of rows contained in the ColumnGroup.
      Returns:
        A Central Moment object.

    - #### rexpandCols

          public AColGroup rexpandCols​(int max,
                                       boolean ignore,
                                       boolean cast,
                                       int nRows)

      Description copied from class: `AColGroup`
      Expand the column group to multiple columns. (one hot encode the column group)
      Specified by:
        `rexpandCols` in class `AColGroup`
      Parameters:
        `max` - The number of columns to expand to and cutoff values at.
        `ignore` - If zero and negative values should be ignored.
        `cast` - If the double values contained should be cast to whole numbers.
        `nRows` - The number of rows in the column group.
      Returns:
        A new column group containing max number of columns.

    - #### getCost

          public double getCost​(ComputationCostEstimator e,
                                int nRows)

      Description copied from class: `AColGroup`
      Get the computation cost associated with this column group.
      Specified by:
        `getCost` in class `AColGroup`
      Parameters:
        `e` - The computation cost estimator
        `nRows` - the number of rows in the column group
      Returns:
        The cost of this column group

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `AColGroup`